' IupCanvas example
' Description : Creates a IUP canvas and uses CD to draw on it

#include once "crt.bi"

'#include once "inc/iup.bi"
'#include once "inc/cd.bi"
#include once "inc/cdiup.bi"

sub _init_ constructor
  IupOpen(0,0)
end sub

sub _exit_ destructor
  IupClose()
end sub


dim shared as cdCanvas ptr cdcanvas = NULL
dim shared as integer drawit = 0

function button_cb cdecl (self as Ihandle ptr, but as integer, press as integer, x as integer, y as integer) as integer
  if (but = IUP_BUTTON1) and (press<>0) then
    cdCanvasUpdateYAxis(cdcanvas, @y)
    cdCanvasPixel(cdcanvas, x, y, CD_BLUE)
    drawit = 1
  else
    cdCanvasClear(cdcanvas)
    drawit = 0
  end if

  return IUP_DEFAULT
end function

function motion_cb cdecl (self as Ihandle ptr, x as integer, y as integer) as integer
  if (drawit) then
    cdCanvasUpdateYAxis(cdcanvas, @y)
    cdCanvasPixel(cdcanvas, x, y, CD_BLUE)
  end if
  return IUP_DEFAULT
end function

function redraw_cb cdecl (self as Ihandle ptr, x as single, y as single) as integer
  cdCanvasActivate(cdcanvas)
  cdCanvasClear(cdcanvas)
  cdCanvasForeground(cdcanvas, CD_BLUE)
  cdCanvasBox(cdcanvas, 0, 100, 0, 100)
  return IUP_DEFAULT
end function


'
' main
'
dim as Ihandle ptr dlg, cnvs

cnvs = IupCanvas( NULL )
IupSetAttribute(cnvs, "SIZE", "300x100")
IupSetCallback(cnvs, "ACTION"   , cast(Icallback,@redraw_cb))
IupSetCallback(cnvs, "BUTTON_CB", cast(Icallback,@button_cb))
IupSetCallback(cnvs, "MOTION_CB", cast(Icallback,@motion_cb))
  
dlg = IupDialog( IupVbox( cnvs, NULL ) )
IupSetAttribute(dlg, "TITLE", "IupCanvas + Canvas Draw" )
IupSetAttribute(dlg, "MARGIN", "10x10")
IupMap( dlg )
  
cdcanvas = cdCreateCanvas(CD_IUP, cnvs)
cdCanvasForeground(cdcanvas, CD_BLUE)
  
IupShowXY(dlg, IUP_CENTER, IUP_CENTER)

IupMainLoop()







