' GetParams.bas
#include once "crt.bi"
#include once "inc/iup.bi"
#include once "inc/iupcontrols.bi"

sub _init_ constructor
  IupOpen(0,0)
  IupControlsOpen()
end sub

sub _exit_ destructor
  IupClose()
end sub

enum
 IUP_GETPARAM_OK     = -1 ' if the user pressed the OK button
 IUP_GETPARAM_INIT   = -2 ' after the dialog is mapped and just before it is shown
 IUP_GETPARAM_CANCEL = -3 ' if the user pressed the Cancel button
 IUP_GETPARAM_HELP   = -4 ' if the user pressed the Help button, if any
end enum 

function param_action cdecl (dialog as Ihandle ptr, param_index as integer, user_data as any ptr) as integer
  select case param_index
  case IUP_GETPARAM_OK:
    printf(!"OK\n")
  case IUP_GETPARAM_INIT:
    printf(!"Map\n")
  case IUP_GETPARAM_CANCEL:
    printf(!"Cancel\n")
  case IUP_GETPARAM_HELP:
    printf(!"Help\n")
  case else
    dim as Ihandle ptr param
    dim as zstring * 50 param_str
    sprintf(param_str, "PARAM%d", param_index)
    param = cast(Ihandle ptr,IupGetAttribute(dialog, param_str))
    printf(!"%s = %s\n", param_str, IupGetAttribute(param, "VALUE"))
  end select
  return 1
end function

'
' main
'
dim as integer       pboolean = 1
dim as integer       pinteger = 3456
dim as single        preal = 3.543
dim as integer       pinteger2 = 192
dim as single        preal2 = 0.5
dim as single        pangle = 90
dim as zstring * 100 pstring = "string text"
dim as zstring * 100 pcolor = "255 0 128"
dim as integer       plist = 2
dim as zstring * 200 pstring2 = !"second text\nsecond line"
dim as zstring * 500 pfile_name = "test.jpg"

if IupGetParam("Title", cast(Iparamcb,@param_action), 0, _
                   !"Boolean: %b[No,Yes]{Boolean Tip}\n" _
                   !"Integer: %i{Integer Tip}\n" _
                   !"Real 1: %r{Real Tip}\n" _
                   !"%t\n" _
                   !"Integer: %i[0,255]{Integer Tip 2}\n" _
                   !"Real 2: %r[-1.5,1.5]{Real Tip 2}\n" _
                   !"%t\n" _
                   !"Angle: %a[0,360]{Angle Tip}\n" _
                   !"String: %s{String Tip}\n" _
                   !"List: %l|item1|item2|item3|{List Tip}\n" _
                   !"File: %f[OPEN|*.bmp;*.jpg|CURRENT|NO|NO]{File Tip}\n" _
                   !"Color: %c{Color Tip}\n" _
                   !"%t\n" _
                   !"Multiline: %m{Multiline Tip}\n", _
                   @pboolean, @pinteger, @preal, @pinteger2, @preal2, @pangle, pstring, @plist, pfile_name, pcolor, pstring2, NULL) then
  
  IupMessagef("IupGetParam", _
              !"Boolean Value: %d\n" _
              !"Integer: %d\n" _
              !"Real 1: %g\n" _
              !"Integer: %d\n" _
              !"Real 2: %g\n" _
              !"Angle: %g\n" _
              !"String: %s\n" _
              !"List Index: %d\n" _
              !"FileName: %s\n" _
              !"Color: %s\n" _
              !"Multiline: %s", _
              pboolean, pinteger, preal, pinteger2, preal2, pangle, pstring, plist, pfile_name, pcolor, pstring2)
end if

