#include once "iupuserclass.bi"

sub _init_ constructor
  IupOpen(0,0)
  ' register our new IUP class
  IupOvalOpen()
end sub

sub _exit_ destructor
  IupClose()
end sub

' value of the slider changed
function valuechanged_cb cdecl(ih as  IHandle ptr) as integer
  dim as single v = IupGetFloat(ih,"VALUE")
  dim as IHandle ptr oval = IupGetHandle("oval")
  if oval then
    ' set the number of points attribute
    IupStoreAttribute(oval,"NUMPOINTS",str(int(v)))
    ' update the text of the label
    dim as IHandle ptr label = IupGetHandle("label")
    if label then 
      IupSetAttribute(label,"TITLE",IupGetAttribute(oval,"NUMPOINTS"))
    end if
    ' and redraw the oval control
    IupRedraw(oval,0)
  end if
  return IUP_DEFAULT
end function

' create our user defined IUP control
dim as IHandle ptr oval = IupOval()
' save the handle (usefull inside of callbacks) 
IupSetHandle("oval",oval)

' create a value slider for changing the number 
' of points attibute of the oval control
dim as IHandle ptr value = IupVal(NULL)
IupSetAttribute(value,"MIN","3.0")
IupSetAttribute(value,"MAX","64.0")
IupSetAttribute(value,"VALUE",IupGetAttribute(oval,"NUMPOINTS"))
IupSetCallback(value,"VALUECHANGED_CB",@valuechanged_cb)

dim as IHandle ptr label = IupLabel(IupGetAttribute(oval,"NUMPOINTS"))
IupSetHandle("label",label)
dim as IHandle ptr dialog = IupDialog(IupVBox(oval, _
                                              IupHBox(IupLabel("number of points:"),value,label,NULL), _
                                              NULL))

IupSetAttribute(dialog, "TITLE", "Test for IupOval()" )

'IupSetAttribute(dialog, "MARGIN", "10x10")
IupShowXY(dialog, IUP_CENTER, IUP_CENTER)

IupMainLoop()







