 
' PPlot_demo.bas

#include once "crt.bi"
#include once "inc/iup_pplot.bi"
#include once "inc/iupcontrols.bi"
#include once "inc/cdpdf.bi"

sub _init_ constructor
  IupOpen(0,0)
  IupControlsOpen()  ' (we use IupTabs() also)
  IupPPlotOpen()
end sub

sub _exit_ destructor
  IupClose()
end sub


#define MAXPLOT 6  ' room for examples


dim shared as IHandle ptr plot(MAXPLOT-1) ' PPlot controls
dim shared as IHandle ptr dial1, dial2, _ ' dials for zooming
                          tgg1 , tgg2 , _ ' auto scale on|off toggles
                          tgg3 , tgg4 , _ ' grid show|hide toggles
                          tgg5 , _        ' legend show|hide toggle
                          tabs            ' tabbed control

function delete_cb cdecl (ih as IHandle ptr, index as integer, sample_index as integer, x as single, y as single) as integer
  printf(!"DELETE_CB(%d, %d, %g, %g)\n", index, sample_index, x, y)
  return IUP_DEFAULT
end function

function select_cb cdecl (ih as IHandle ptr, index as integer, sample_index as integer, x as single, y as single, select_ as integer) as integer
  printf(!"SELECT_CB(%d, %d, %g, %g, %d)\n", index, sample_index, x, y, select_)
  return IUP_DEFAULT
end function

function edit_cb cdecl (ih as IHandle ptr, index as integer, sample_index as integer, x as single, y as single, new_x as single ptr, new_y as single ptr) as integer
  printf(!"EDIT_CB(%d, %d, %g, %g, %g, %g)\n", index, sample_index, x, y, *new_x, *new_y)
  return IUP_DEFAULT
end function

function postdraw_cb cdecl (ih as IHandle ptr, cnv as cdCanvas ptr) as integer
  dim as integer ix, iy
  IupPPlotTransform(ih, 0.003, 0.02, @ix, @iy)
  cdCanvasFont(cnv, NULL, CD_BOLD, 10)
  cdCanvasTextAlignment(cnv, CD_SOUTH)
  cdCanvasText(cnv, ix, iy, "My Inline Legend")
  printf(!"POSTDRAW_CB()\n")
  return IUP_DEFAULT
end function

function predraw_cb cdecl (ih as IHandle ptr, cnv as cdCanvas ptr) as integer 
  printf(!"PREDRAW_CB()\n")
  return IUP_DEFAULT
end function

sub InitPlots()
  dim as integer theI
  dim as single x, y

  ' PLOT 0 - MakeExamplePlot1
  IupSetAttribute(plot(0), "TITLE", "AutoScale")
  IupSetAttribute(plot(0), "MARGINTOP", "40")
  IupSetAttribute(plot(0), "MARGINLEFT", "40")
  IupSetAttribute(plot(0), "MARGINBOTTOM", "50")
  IupSetAttribute(plot(0), "TITLEFONTSIZE", "16")
  IupSetAttribute(plot(0), "AXS_XLABEL", "gnu (Foo)")
  IupSetAttribute(plot(0), "AXS_YLABEL", "Space (m^3)")
  IupSetAttribute(plot(0), "AXS_YFONTSIZE", "7")
  IupSetAttribute(plot(0), "AXS_YTICKFONTSIZE", "7")
  IupSetAttribute(plot(0), "LEGENDSHOW", "YES")
  IupSetAttribute(plot(0), "AXS_XFONTSIZE", "10")
  IupSetAttribute(plot(0), "AXS_YFONTSIZE", "10")
  IupSetAttribute(plot(0), "AXS_XLABELCENTERED", "NO")
  IupSetAttribute(plot(0), "AXS_YLABELCENTERED", "NO")
  
  ' IupSetAttribute(plot(0), "USE_IMAGERGB", "YES")
  ' IupSetAttribute(plot(0), "USE_GDI+", "YES")

  dim as single theFac = 1.0/(100*100*100)
  IupPPlotBegin(plot(0), 0)
  for theI=-100 to 100
    x = theI+50
    y = theFac*theI*theI*theI
    IupPPlotAdd(plot(0), x, y)
  next
  IupPPlotEnd(plot(0))
  IupSetAttribute(plot(0), "DS_LINEWIDTH", "3")
  IupSetAttribute(plot(0), "DS_LEGEND", "Line")

  theFac = 2.0/100.0
  IupPPlotBegin(plot(0), 0)
  for theI=-100 to 100
    x = theI
    y = -theFac*theI
    IupPPlotAdd(plot(0), x, y)
  next
  IupPPlotEnd(plot(0))
  IupSetAttribute(plot(0), "DS_LEGEND", "Curve 1")

  IupPPlotBegin(plot(0), 0)
  for theI=-100 to 100 
    x = 0.01*theI*theI-30
    y = 0.01*theI
    IupPPlotAdd(plot(0), x, y)
  next
  IupPPlotEnd(plot(0))
  IupSetAttribute(plot(0), "DS_LEGEND", "Curve 2")

  ' PLOT 1 - MakeExamplePlot2
  IupSetAttribute(plot(1), "TITLE", "No Autoscale+No CrossOrigin")
  IupSetAttribute(plot(1), "TITLEFONTSIZE", "16")
  IupSetAttribute(plot(1), "MARGINTOP", "40")
  IupSetAttribute(plot(1), "MARGINLEFT", "55")
  IupSetAttribute(plot(1), "MARGINBOTTOM", "50")
  IupSetAttribute(plot(1), "BGCOLOR", "0 192 192")
  IupSetAttribute(plot(1), "AXS_XLABEL", "Tg (X)")
  IupSetAttribute(plot(1), "AXS_YLABEL", "Tg (Y)")
  IupSetAttribute(plot(1), "AXS_XAUTOMIN", "NO")
  IupSetAttribute(plot(1), "AXS_XAUTOMAX", "NO")
  IupSetAttribute(plot(1), "AXS_YAUTOMIN", "NO")
  IupSetAttribute(plot(1), "AXS_YAUTOMAX", "NO")
  IupSetAttribute(plot(1), "AXS_XMIN", "10")
  IupSetAttribute(plot(1), "AXS_XMAX", "60")
  IupSetAttribute(plot(1), "AXS_YMIN", "-0.5")
  IupSetAttribute(plot(1), "AXS_YMAX", "0.5")
  IupSetAttribute(plot(1), "AXS_XCROSSORIGIN", "NO")
  IupSetAttribute(plot(1), "AXS_YCROSSORIGIN", "NO")
  IupSetAttribute(plot(1), "AXS_XFONTSTYLE", "BOLD")
  IupSetAttribute(plot(1), "AXS_YFONTSTYLE", "BOLD")
  IupSetAttribute(plot(1), "AXS_XREVERSE", "YES")
  IupSetAttribute(plot(1), "GRIDCOLOR", "128 255 128")
  IupSetAttribute(plot(1), "GRIDLINESTYLE", "DOTTED")
  IupSetAttribute(plot(1), "GRID", "YES")
  IupSetAttribute(plot(1), "LEGENDSHOW", "YES")

  theFac = 1.0/(100*100*100)
  IupPPlotBegin(plot(1), 0)
  for theI=0 to 100
    x = theI
    y = theFac*theI*theI*theI
    IupPPlotAdd(plot(1), x, y)
  next
  IupPPlotEnd(plot(1))

  theFac = 2.0/100
  IupPPlotBegin(plot(1), 0)
  for theI=0 to 100 
    x = theI
    y = -theFac*theI
    IupPPlotAdd(plot(1), x, y)
  next
  IupPPlotEnd(plot(1))

  ' PLOT 2 - MakeExamplePlot4
  IupSetAttribute(plot(2), "TITLE", "Log Scale")
  IupSetAttribute(plot(2), "TITLEFONTSIZE", "16")
  IupSetAttribute(plot(2), "MARGINTOP", "40")
  IupSetAttribute(plot(2), "MARGINLEFT", "70")
  IupSetAttribute(plot(2), "MARGINBOTTOM", "50")
  IupSetAttribute(plot(2), "GRID", "YES")
  IupSetAttribute(plot(2), "AXS_XSCALE", "LOG10")
  IupSetAttribute(plot(2), "AXS_YSCALE", "LOG2")
  IupSetAttribute(plot(2), "AXS_XLABEL", "Tg (X)")
  IupSetAttribute(plot(2), "AXS_YLABEL", "Tg (Y)")
  IupSetAttribute(plot(2), "AXS_XFONTSTYLE", "BOLD")
  IupSetAttribute(plot(2), "AXS_YFONTSTYLE", "BOLD")

  theFac = 100.0/(100*100*100)
  IupPPlotBegin(plot(2), 0)
  for theI=0 to 100 
    x = 0.0001+ theI*0.001
    y = 0.01 + theFac*theI*theI*theI
    IupPPlotAdd(plot(2), x, y)
  next
  IupPPlotEnd(plot(2))
  IupSetAttribute(plot(2), "DS_COLOR", "100 100 200")

  ' PLOT 3 - MakeExamplePlot5
  IupSetAttribute(plot(3), "TITLE", "Bar Mode")
  IupSetAttribute(plot(3), "TITLEFONTSIZE", "16")
  IupSetAttribute(plot(3), "MARGINTOP", "40")
  IupSetAttribute(plot(3), "MARGINLEFT", "30")
  IupSetAttribute(plot(3), "MARGINBOTTOM", "30")
  dim as const zstring ptr kLables(11) = {@"jan",@"feb", @"mar", @"apr", @"may", @"jun", @"jul", @"aug", @"sep", @"oct", @"nov", @"dec"}
  dim as const single kData(11) = {1,2,3,4,5,6,7,8,9,0,1,2}

  IupPPlotBegin(plot(3), 1)
  for theI=0 to 11 
    IupPPlotAddStr(plot(3), _
                   kLables(theI), _
                   kData(theI))
  next  
  IupPPlotEnd(plot(3))
  IupSetAttribute(plot(3), "DS_COLOR", "100 100 200")
  IupSetAttribute(plot(3), "DS_MODE", "BAR")

  ' PLOT 4 - MakeExamplePlot6
  IupSetAttribute(plot(4), "TITLE", "Marks Mode")
  IupSetAttribute(plot(4), "TITLEFONTSIZE", "16")
  IupSetAttribute(plot(4), "MARGINTOP", "40")
  IupSetAttribute(plot(4), "MARGINLEFT", "45")
  IupSetAttribute(plot(4), "MARGINBOTTOM", "40")
  IupSetAttribute(plot(4), "AXS_XAUTOMIN", "NO")
  IupSetAttribute(plot(4), "AXS_XAUTOMAX", "NO")
  IupSetAttribute(plot(4), "AXS_YAUTOMIN", "NO")
  IupSetAttribute(plot(4), "AXS_YAUTOMAX", "NO")
  IupSetAttribute(plot(4), "AXS_XMIN", "0")
  IupSetAttribute(plot(4), "AXS_XMAX", "0.011")
  IupSetAttribute(plot(4), "AXS_YMIN", "0")
  IupSetAttribute(plot(4), "AXS_YMAX", "0.22")
  IupSetAttribute(plot(4), "AXS_XCROSSORIGIN", "NO")
  IupSetAttribute(plot(4), "AXS_YCROSSORIGIN", "NO")
  IupSetAttribute(plot(4), "AXS_XTICKFORMAT", "%1.3f")
  IupSetAttribute(plot(4), "LEGENDSHOW", "YES")
  IupSetAttribute(plot(4), "LEGENDPOS", "BOTTOMRIGHT")

  theFac = 100.0/(100*100*100)
  IupPPlotBegin(plot(4), 0)
  for theI=0 to 10 
    x = 0.0001+theI*0.001
    y = 0.01+theFac*theI*theI
    IupPPlotAdd(plot(4), x, y)
  next
  IupPPlotEnd(plot(4))
  IupSetAttribute(plot(4), "DS_MODE", "MARKLINE")
  IupSetAttribute(plot(4), "DS_SHOWVALUES", "YES")

  IupPPlotBegin(plot(4), 0)
  for theI=0 to 10
    x = 0.0001+theI*0.001
    y = 0.2-theFac*theI*theI
    IupPPlotAdd(plot(4), x, y)
  next
  IupPPlotEnd(plot(4))
  IupSetAttribute(plot(4), "DS_MODE", "MARK")
  IupSetAttribute(plot(4), "DS_MARKSTYLE", "HOLLOW_CIRCLE")
  
  ' PLOT 5 - MakeExamplePlot8
  IupSetAttribute(plot(5), "TITLE", "Data Selection and Editing")
  IupSetAttribute(plot(5), "TITLEFONTSIZE", "16")
  IupSetAttribute(plot(5), "MARGINTOP", "40")

  theFac = 100.0/(100*100*100)
  IupPPlotBegin(plot(5), 0)
  for theI=-10 to 10
    x = 0.001*theI
    y = 0.01 + theFac*theI*theI*theI
    IupPPlotAdd(plot(5), x, y)
  next
  IupPPlotEnd(plot(5))
  IupSetAttribute(plot(5), "DS_COLOR", "100 100 200")
  IupSetAttribute(plot(5), "DS_EDIT", "YES")
  IupSetCallback(plot(5), "DELETE_CB"  , cast(Icallback,@delete_cb))
  IupSetCallback(plot(5), "SELECT_CB"  , cast(Icallback,@select_cb))
  IupSetCallback(plot(5), "POSTDRAW_CB", cast(Icallback,@postdraw_cb))
  IupSetCallback(plot(5), "PREDRAW_CB" , cast(Icallback,@predraw_cb))
  IupSetCallback(plot(5), "EDIT_CB"    , cast(Icallback,@edit_cb))
end sub

function tabs_get_index() as integer
  dim as Ihandle ptr curr_tab = IupGetHandle(IupGetAttribute(tabs, "VALUE"))
  dim as zstring ptr ss = IupGetAttribute(curr_tab, "TABTITLE")
  ss += 5 ' Skip "Plot "
  return atoi(ss)
end function

' Some processing required by current tab change:
' the controls at left will be updated according to current plot props
function tabs_tabchange_cb cdecl (self as IHandle ptr, new_tab as IHandle ptr) as integer
  dim as integer ii=0

  dim as zstring ptr ss = IupGetAttribute(new_tab, "TABTITLE")
  ss += 5 ' Skip "Plot "
  ii = atoi(ss)

  ' autoscaling
  ' X axis
  if (IupGetInt(plot(ii), "AXS_XAUTOMIN") and IupGetInt(plot(ii), "AXS_XAUTOMAX")) then
    IupSetAttribute(tgg2, "VALUE", "ON")
    IupSetAttribute(dial2, "ACTIVE", "NO")
  else
    IupSetAttribute(tgg2, "VALUE", "OFF")
    IupSetAttribute(dial2, "ACTIVE", "YES")
  end if
  ' Y axis
  if (IupGetInt(plot(ii), "AXS_YAUTOMIN") and IupGetInt(plot(ii), "AXS_YAUTOMAX")) then
    IupSetAttribute(tgg1, "VALUE", "ON")
    IupSetAttribute(dial1, "ACTIVE", "NO")
  else
    IupSetAttribute(tgg1, "VALUE", "OFF")
    IupSetAttribute(dial1, "ACTIVE", "YES")
  end if

  ' grid
  if (IupGetInt(plot(ii), "GRID")) then
    IupSetAttribute(tgg3, "VALUE", "ON")
    IupSetAttribute(tgg4, "VALUE", "ON")
  else
    ' X axis
    if (*IupGetAttribute(plot(ii), "GRID") = "V") then
      IupSetAttribute(tgg3, "VALUE", "ON")
    else
      IupSetAttribute(tgg3, "VALUE", "OFF")
    end if  
    ' Y axis
    if (*IupGetAttribute(plot(ii), "GRID") = "H") then
      IupSetAttribute(tgg4, "VALUE", "ON")
    else
      IupSetAttribute(tgg4, "VALUE", "OFF")
    end if  
  end if
  
  ' legend
  if (IupGetInt(plot(ii), "LEGENDSHOW")) then
    IupSetAttribute(tgg5, "VALUE", "ON")
  else
    IupSetAttribute(tgg5, "VALUE", "OFF")
  end if  

  return IUP_DEFAULT
end function


' show/hide V grid
function tgg3_cb cdecl(self as IHandle ptr, v as integer) as integer
  dim as integer ii = tabs_get_index()

  if (v) then
    if (IupGetInt(tgg4, "VALUE")) then
      IupSetAttribute(plot(ii), "GRID", "YES")
    else
      IupSetAttribute(plot(ii), "GRID", "VERTICAL")
    end if
  else
    if (IupGetInt(tgg4, "VALUE")=NULL) then
      IupSetAttribute(plot(ii), "GRID", "NO")
    else
      IupSetAttribute(plot(ii), "GRID", "HORIZONTAL")
    end if  
  end if

  IupSetAttribute(plot(ii), "REDRAW", NULL)

  return IUP_DEFAULT
end function


' show/hide H grid
function tgg4_cb cdecl (self as IHandle ptr, v as integer) as integer
  dim as integer ii = tabs_get_index()

  if (v) then
    if (IupGetInt(tgg3, "VALUE")) then
      IupSetAttribute(plot(ii), "GRID", "YES")
    else
      IupSetAttribute(plot(ii), "GRID", "HORIZONTAL")
    end if  
  else
    if (IupGetInt(tgg3, "VALUE")=NULL) then
      IupSetAttribute(plot(ii), "GRID", "NO")
    else
      IupSetAttribute(plot(ii), "GRID", "VERTICAL")
    end if  
  end if

  IupSetAttribute(plot(ii), "REDRAW", NULL)

  return IUP_DEFAULT
end function


' show/hide legend
function tgg5_cb cdecl (self as IHandle ptr, v as integer) as integer
  dim as integer ii = tabs_get_index()

  if (v) then
    IupSetAttribute(plot(ii), "LEGENDSHOW", "YES")
  else
    IupSetAttribute(plot(ii), "LEGENDSHOW", "NO")
  end if  

  IupSetAttribute(plot(ii), "REDRAW", NULL)

  return IUP_DEFAULT
end function


' autoscale Y
function tgg1_cb cdecl (self as IHandle ptr, v as integer) as integer
  dim as integer ii = tabs_get_index()

  if (v) then
    IupSetAttribute(dial1, "ACTIVE", "NO")
    IupSetAttribute(plot(ii), "AXS_YAUTOMIN", "YES")
    IupSetAttribute(plot(ii), "AXS_YAUTOMAX", "YES")
  else
    IupSetAttribute(dial1, "ACTIVE", "YES")
    IupSetAttribute(plot(ii), "AXS_YAUTOMIN", "NO")
    IupSetAttribute(plot(ii), "AXS_YAUTOMAX", "NO")
  end if

  IupSetAttribute(plot(ii), "REDRAW", NULL)

  return IUP_DEFAULT
end function


' autoscale X
function tgg2_cb cdecl (self as IHandle ptr, v as integer) as integer
  dim as integer ii = tabs_get_index()

  if (v) then
    IupSetAttribute(dial2, "ACTIVE", "NO")
    IupSetAttribute(plot(ii), "AXS_XAUTOMIN", "YES")
    IupSetAttribute(plot(ii), "AXS_XAUTOMAX", "YES")
  else
    IupSetAttribute(dial2, "ACTIVE", "YES")
    IupSetAttribute(plot(ii), "AXS_XAUTOMIN", "NO")
    IupSetAttribute(plot(ii), "AXS_XAUTOMAX", "NO")
  end if

  IupSetAttribute(plot(ii), "REDRAW", NULL)

  return IUP_DEFAULT
end function


' Y zoom
function dial1_btndown_cb cdecl (self as IHandle ptr, angle as double) as integer
  dim as integer ii = tabs_get_index()

  IupStoreAttribute(plot(ii), "OLD_YMIN", IupGetAttribute(plot(ii), "AXS_YMIN"))
  IupStoreAttribute(plot(ii), "OLD_YMAX", IupGetAttribute(plot(ii), "AXS_YMAX"))

  return IUP_DEFAULT
end function

function dial1_btnup_cb cdecl (self as IHandle ptr, angle as double) as integer
  dim as integer ii = tabs_get_index()
  dim as double x1, x2, xm
  dim as zstring ptr ss

  x1 = IupGetFloat(plot(ii), "OLD_YMIN")
  x2 = IupGetFloat(plot(ii), "OLD_YMAX")

  ss = IupGetAttribute(plot(ii), "AXS_YMODE")
  if ( ss<>NULL) andalso ( ss[3]=asc("2") ) then
    ' LOG2:  one circle will zoom 2 times
    xm = 4.0 * fabs(angle) / 3.141592
    if (angle>0.0) then 
      x2 /= xm: x1 *= xm 
    else 
      x2 *= xm: x1 /= xm 
    end if
  end if

  if ( ss<>NULL) andalso (ss[3]=asc("1") ) then
    ' LOG10:  one circle will zoom 10 times
    xm = 10.0 * fabs(angle) / 3.141592
    if (angle>0.0) then 
      x2 /= xm: x1 *= xm 
    else 
      x2 *= xm: x1 /= xm
    end if   
  else
    ' LIN: one circle will zoom 2 times
    xm = (x1 + x2) / 2.0
    x1 = xm - (xm - x1)*(1.0-angle*1.0/3.141592)
    x2 = xm + (x2 - xm)*(1.0-angle*1.0/3.141592)
  end if

  if (x1<x2) then
    IupSetfAttribute(plot(ii), "AXS_YMIN", "%g", x1)
    IupSetfAttribute(plot(ii), "AXS_YMAX", "%g", x2)
  end if

  IupSetAttribute(plot(ii), "REDRAW", NULL)

  return IUP_DEFAULT
end function


' X zoom
function dial2_btndown_cb cdecl (self as IHandle ptr, angle as double) as integer
  dim as integer ii = tabs_get_index()

  IupStoreAttribute(plot(ii), "OLD_XMIN", IupGetAttribute(plot(ii), "AXS_XMIN"))
  IupStoreAttribute(plot(ii), "OLD_XMAX", IupGetAttribute(plot(ii), "AXS_XMAX"))

  return IUP_DEFAULT
end function

function dial2_btnup_cb(self as IHandle ptr, angle as double) as integer
  dim as integer ii = tabs_get_index()
  dim as double x1, x2, xm

  x1 = IupGetFloat(plot(ii), "OLD_XMIN")
  x2 = IupGetFloat(plot(ii), "OLD_XMAX")

  xm = (x1 + x2) / 2.0

  x1 = xm - (xm - x1)*(1.0-angle*1.0/3.141592) ' one circle will zoom 2 times
  x2 = xm + (x2 - xm)*(1.0-angle*1.0/3.141592)

  IupSetfAttribute(plot(ii), "AXS_XMIN", "%g", x1)
  IupSetfAttribute(plot(ii), "AXS_XMAX", "%g", x2)

  IupSetAttribute(plot(ii), "REDRAW", NULL)

  return IUP_DEFAULT
end function

function bt1_cb cdecl (self as IHandle ptr) as integer
  printf(!"bt1_cb\n")
  dim as integer ii = tabs_get_index()
  dim as cdCanvas ptr cnv = cdCreateCanvas(CD_PDF, @"pplot.pdf -o")
  IupPPlotPaintTo(plot(ii), cnv)
  cdKillCanvas(cnv)
  return IUP_DEFAULT
end function


'
' main
'
dim as IHandle ptr vboxr(MAXPLOT) ' tabs containing the plots
dim as IHandle ptr dlg, vboxl, hbox, lbl1, lbl2, lbl3, bt1, boxinfo, boxdial1, boxdial2, f1, f2
dim as integer ii

' create plots
for ii=0 to MAXPLOT-1
  plot(ii) = IupPPlot()
next
  
' left panel: plot control
' Y zooming
dial1 = IupDial("VERTICAL")
lbl1 = IupLabel("+")
lbl2 = IupLabel("-")
boxinfo = IupVbox(lbl1, IupFill(), lbl2, NULL)
boxdial1 = IupHbox(boxinfo, dial1, NULL)

IupSetAttribute(boxdial1, "ALIGNMENT", "ACENTER")
IupSetAttribute(boxinfo, "ALIGNMENT", "ACENTER")
IupSetAttribute(boxinfo, "SIZE", "20x52")
IupSetAttribute(boxinfo, "GAP", "2")
IupSetAttribute(boxinfo, "MARGIN", "4")
IupSetAttribute(boxinfo, "EXPAND", "YES")
IupSetAttribute(lbl1, "EXPAND", "NO")
IupSetAttribute(lbl2, "EXPAND", "NO")

IupSetAttribute(dial1, "ACTIVE", "NO")
IupSetAttribute(dial1, "SIZE", "20x52")
IupSetCallback(dial1, "BUTTON_PRESS_CB"  , cast(Icallback,@dial1_btndown_cb))
IupSetCallback(dial1, "MOUSEMOVE_CB"     , cast(Icallback,@dial1_btnup_cb))
IupSetCallback(dial1, "BUTTON_RELEASE_CB", cast(Icallback,@dial1_btnup_cb))

tgg1 = IupToggle("Y Autoscale", NULL)
IupSetCallback(tgg1, "ACTION", cast(Icallback,@tgg1_cb))
IupSetAttribute(tgg1, "VALUE", "ON")

f1 = IupFrame( IupVbox(boxdial1, tgg1, NULL) )
IupSetAttribute(f1, "TITLE", "Y Zoom")

' X zooming
dial2 = IupDial("HORIZONTAL")
lbl1 = IupLabel("-")
lbl2 = IupLabel("+")
boxinfo = IupHbox(lbl1, IupFill(), lbl2, NULL)
boxdial2 = IupVbox(dial2, boxinfo, NULL)

IupSetAttribute(boxdial2, "ALIGNMENT", "ACENTER")
IupSetAttribute(boxinfo, "ALIGNMENT", "ACENTER")
IupSetAttribute(boxinfo, "SIZE", "64x16")
IupSetAttribute(boxinfo, "GAP", "2")
IupSetAttribute(boxinfo, "MARGIN", "4")
IupSetAttribute(boxinfo, "EXPAND", "HORIZONTAL")

IupSetAttribute(lbl1, "EXPAND", "NO")
IupSetAttribute(lbl2, "EXPAND", "NO")

IupSetAttribute(dial2, "ACTIVE", "NO")
IupSetAttribute(dial2, "SIZE", "64x16")
IupSetCallback(dial2, "BUTTON_PRESS_CB" , cast(Icallback,@dial2_btndown_cb))
IupSetCallback(dial2, "MOUSEMOVE_CB"     , cast(Icallback,@dial2_btnup_cb))
IupSetCallback(dial2, "BUTTON_RELEASE_CB", cast(Icallback,@dial2_btnup_cb))

tgg2 = IupToggle("X Autoscale", NULL)
IupSetCallback(tgg2, "ACTION", cast(Icallback,@tgg2_cb))

f2 = IupFrame( IupVbox(boxdial2, tgg2, NULL) )
IupSetAttribute(f2, "TITLE", "X Zoom")

lbl1 = IupLabel("")
IupSetAttribute(lbl1, "SEPARATOR", "HORIZONTAL")

tgg3 = IupToggle("Vertical Grid", NULL)
IupSetCallback(tgg3, "ACTION", cast(Icallback,@tgg3_cb))

tgg4 = IupToggle("Horizontal Grid", NULL)
IupSetCallback(tgg4, "ACTION", cast(Icallback,@tgg4_cb))

lbl2 = IupLabel("")
IupSetAttribute(lbl2, "SEPARATOR", "HORIZONTAL")

tgg5 = IupToggle("Legend", NULL)
IupSetCallback(tgg5, "ACTION", cast(Icallback,@tgg5_cb))

lbl3 = IupLabel("")
IupSetAttribute(lbl3, "SEPARATOR", "HORIZONTAL")

bt1 = IupButton("Export PDF", NULL)
IupSetCallback(bt1, "ACTION", cast(Icallback,@bt1_cb))

vboxl = IupVbox(f1, f2, lbl1, tgg3, tgg4, lbl2, tgg5, lbl3, bt1, NULL)
IupSetAttribute(vboxl, "GAP", "4")
IupSetAttribute(vboxl, "EXPAND", "NO")

' right panel: tabs with plots
for ii=0 to MAXPLOT-1
  vboxr(ii) = IupVbox(plot(ii), NULL) ' each plot a tab
  IupSetfAttribute(vboxr(ii), "TABTITLE", "Plot %d", ii) ' name each tab
next

vboxr(MAXPLOT) = NULL ' mark end of vector

tabs = IupTabsv(@vboxr(0)) ' create tabs
IupSetCallback(tabs, "TABCHANGE_CB", cast(Icallback,@tabs_tabchange_cb))

' dialog
hbox = IupHbox(vboxl, tabs, NULL)
IupSetAttribute(hbox, "MARGIN", "4x4")
IupSetAttribute(hbox, "GAP", "10")
  
dlg = IupDialog(hbox)
IupSetAttributes(dlg, "SIZE=500x240" )
IupSetAttribute(dlg, "TITLE", "IupPPlot demo")

InitPlots() ' It must be able to be done independent of dialog Mapping

tabs_tabchange_cb(tabs, vboxr(0))

IupShowXY(dlg, IUP_CENTER, IUP_CENTER)
IupSetAttribute(dlg, "SIZE", NULL)

IupMainLoop()











