#ifndef __FTExtrudeGlyph_bi_
#define __FTExtrudeGlyph_bi_

extern "c"

/'*
 * Create a specialisation of FTGLglyph for creating tessellated
 * extruded polygon glyphs.
 *
 * @param glyph The Freetype glyph to be processed
 * @param depth The distance along the z axis to extrude the glyph
 * @param frontOutset outset contour size
 * @param backOutset outset contour size
 * @param useDisplayList Enable or disable the use of Display Lists
 *                       for this glyph
 *                       <code>true</code> turns ON display lists.
 *                       <code>false</code> turns OFF display lists.
 * @return  An FTGLglyph* object.
 '/
declare function ftglCreateExtrudeGlyph(glyph as FT_GlyphSlot, depth as single, frontOutset as single, backOutset as single, useDisplayList as integer) as FTGLglyph ptr

end extern

#endif

