#ifndef __FTLayout_bi__
#define __FTLayout_bi__

' FTGLlayout is the interface for layout managers that render text.
type _FTGLlayout as any : type FTGLlayout as _FTGLlayout

extern "c"

/'*
 * Destroy an FTGL layout object.
 *
 * @param layout  An FTGLlayout* object.
 '/
declare sub ftglDestroyLayout(layout as FTGLlayout ptr)

/'*
 * Get the bounding box for a string.
 *
 * @param layout  An FTGLlayout* object.
 * @param string  A char buffer
 * @param bounds  An array of 6 float values where the bounding box's lower
 *                left near and upper right far 3D coordinates will be stored.
 '/
declare sub ftglGetLayoutBBox(layout as FTGLlayout ptr, string_ as const zstring ptr, bounds as single ptr)

/'*
 * Render a string of characters.
 *
 * @param layout  An FTGLlayout* object.
 * @param string  Char string to be output.
 * @param mode  Render mode to display.
 '/
declare sub ftglRenderLayout(layout as FTGLlayout ptr, string_ as const zstring ptr, mode as integer)

/'*
 * Query a layout for errors.
 *
 * @param layout  An FTGLlayout* object.
 * @return  The current error code.
 '/
declare function ftglGetLayoutError(layout as FTGLlayout ptr) as FT_Error

end extern

#endif
