#ifndef __FTTextureGlyph_bi__
#define __FTTextureGlyph_bi__

extern "c"

/'*
 * Create a specialisation of FTGLglyph for creating pixmaps.
 *
 * @param glyph The Freetype glyph to be processed.
 * @param id  The id of the texture that this glyph will be drawn in.
 * @param xOffset  The x offset into the parent texture to draw this glyph.
 * @param yOffset  The y offset into the parent texture to draw this glyph.
 * @param width  The width of the parent texture.
 * @param height  The height (number of rows) of the parent texture.
 * @return  An FTGLglyph* object.
 '/
declare function ftglCreateTextureGlyph(glyph as FT_GlyphSlot, id as integer, xOffset as integer, yOffset as integer, w as integer, h as integer) as FTGLglyph ptr

end extern

#endif
