#ifndef __IM_COLORHSI_BI__
#define __IM_COLORHSI_BI__

#inlude once "im.bi"

extern "c"

' HSI Color Coordinate System Conversions

' HSI is just the RGB color space written in a different coordinate system.
' "I" is defined along the cube diagonal. It ranges from 0 (black) to 1 (white).
' HS are the polar coordinates of a plane normal to "I".
' "S" is the normal distance from the diagonal of the RGB cube. It ranges from 0 to 1.
' "H" is the angle starting from the red vector, given in degrees.
' This is not a new color space, this is exactly the same gammut as RGB.

' Returns I where S is maximum given H (here in radians).
_DF_ imColorHSI_ImaxS(h as single, cosh as double, sinh as double) as single

' Converts from RGB to HSI.
_DS_ imColorRGB2HSI(r as single, g as single, b as single, h as single ptr, s as single ptr, i as single ptr)

' Converts from RGB (byte) to HSI.
_DS_ imColorRGB2HSIbyte(r as ubyte, g as ubyte, b as ubyte, h as single ptr, s as single ptr, i as single ptr)

' Converts from HSI to RGB.
_DS_ imColorHSI2RGB(h as single, s as single, i as single, r as single ptr, g as single ptr, b as single ptr)

' Converts from HSI to RGB (byte).
_DS_ imColorHSI2RGBbyte(h as single, s as single, i as single, r as ubyte ptr, g as ubyte ptr, b as ubyte ptr)

end extern

#endif
