#ifndef __IM_KERNEL_BI__
#define __IM_KERNEL_BI__


extern "c"


' Kernel Generators


/' Creates a kernel with the following values:
   1  2  1
   0  0  0
  -1 -2 -1 '/
_DF_ imKernelSobel() as imImage ptr

/' Creates a kernel with the following values:
   1  1  1
   0  0  0
  -1 -1 -1'/
_DF_ imKernelPrewitt() as imImage ptr

/' Creates a kernel with the following values:
   5  5  5
  -3  0 -3
  -3 -3 -3 '/
_DF_ imKernelKirsh() as imImage ptr

/' Creates a kernel with the following values:
   0 -1  0 
  -1  4 -1 
   0 -1  0 '/
_DF_ imKernelLaplacian4() as imImage ptr

/' Creates a kernel with the following values:
  -1 -1 -1 
  -1  8 -1 
  -1 -1 -1 '/
_DF_ imKernelLaplacian8() as imImage ptr

/' Creates a kernel with the following values:
   0 -1 -1 -1  0
  -1  0  1  0 -1
  -1  1  8  1 -1
  -1  0  1  0 -1
   0 -1 -1 -1  0 '/
_DF_ imKernelLaplacian5x5() as imImage ptr

/' Creates a kernel with the following values:
  -1 -1 -1 -1 -1 -1 -1
  -1 -1 -1 -1 -1 -1 -1
  -1 -1 -1 -1 -1 -1 -1
  -1 -1 -1 48 -1 -1 -1
  -1 -1 -1 -1 -1 -1 -1
  -1 -1 -1 -1 -1 -1 -1
  -1 -1 -1 -1 -1 -1 -1 '/
_DF_ imKernelLaplacian7x7() as imImage ptr

/' Creates a kernel with the following values:
  0 -1 0
  0  1 0
  0  0 0 '/
_DF_ imKernelGradian3x3() as imImage ptr

/' Creates a kernel with the following values:
   0 -1 -1  0  1  1  0
  -1 -2 -2  0  2  2  1
  -1 -2 -3  0  3  2  1
  -1 -2 -3  0  3  2  1
  -1 -2 -3  0  3  2  1
  -1 -2 -2  0  2  2  1
   0 -1 -1  0  1  1  0 '/
_DF_ imKernelGradian7x7() as imImage ptr

/' Creates a kernel with the following values:
  -1 0 0 
   0 0 0 
   0 0 1 '/
_DF_ imKernelSculpt() as imImage ptr

/' Creates a kernel with the following values:
  1 1 1 
  1 1 1 
  1 1 1 '/
_DF_ imKernelMean3x3() as imImage ptr

/' Creates a kernel with the following values:
  1 1 1 1 1 
  1 1 1 1 1 
  1 1 1 1 1 
  1 1 1 1 1 
  1 1 1 1 1 '/
_DF_ imKernelMean5x5() as imImage ptr

/' Creates a kernel with the following values:
  0 1 1 1 0 
  1 1 1 1 1 
  1 1 1 1 1 
  1 1 1 1 1 
  0 1 1 1 0 '/
_DF_ imKernelCircularMean5x5();

/' Creates a kernel with the following values:
  1 1 1 1 1 1 1 
  1 1 1 1 1 1 1 
  1 1 1 1 1 1 1 
  1 1 1 1 1 1 1 
  1 1 1 1 1 1 1 
  1 1 1 1 1 1 1 
  1 1 1 1 1 1 1 '/
_DF_ imKernelMean7x7() as imImage ptr

/' Creates a kernel with the following values:
  0 0 1 1 1 0 0 
  0 1 1 1 1 1 0 
  1 1 1 1 1 1 1 
  1 1 1 1 1 1 1 
  1 1 1 1 1 1 1 
  0 1 1 1 1 1 0 
  0 0 1 1 1 0 0 '/
_DF_ imKernelCircularMean7x7() as imImage ptr

/' Creates a kernel with the following values:
  1 2 1 
  2 4 2 
  1 2 1 '/
_DF_ imKernelGaussian3x3() as imImage ptr

/' Creates a kernel with the following values:
  1  4  6  4 1 
  4 16 24 16 4 
  6 24 36 24 6 
  4 16 24 16 4 
  1  4  6  4 1 '/
_DF_ imKernelGaussian5x5() as imImage ptr

/' Creates a kernel with the following values:
  1 2 3 2 1 
  2 4 6 4 2 
  3 6 9 6 3 
  2 4 6 4 2 
  1 2 3 2 1 '/
_DF_ imKernelBarlett5x5() as imImage ptr

/' Creates a kernel with the following values:
   0 -1 -1 -1  0 
  -1 -1  3 -1 -1 
  -1  3  4  3 -1 
  -1 -1  3 -1 -1 
   0 -1 -1 -1  0 '/
_DF_ imKernelTopHat5x5() as imImage ptr

/' Creates a kernel with the following values:
   0  0 -1 -1 -1  0  0
   0 -1 -1 -1 -1 -1  0 
  -1 -1  3  3  3 -1 -1 
  -1 -1  3  4  3 -1 -1 
  -1 -1  3  3  3 -1 -1 
   0 -1 -1 -1 -1 -1  0 
   0  0 -1 -1 -1  0  0 '/
_DF_ imKernelTopHat7x7() as imImage ptr

/' Creates a kernel with the following values:
   0 -1 -2 -1  0 
  -1 -4  0 -4 -1 
  -2  0 40  0 -2 
  -1 -4  0 -4 -1 
   0 -1 -2 -1  0 '/
_DF_ imKernelEnhance() as imImage ptr

end extern

#endif

