#ifndef __iup_bi__
#define __iup_bi__

' see copyright notice at the file iup.txt

#include once "iupcommon.bi"
#include once "iupkey.bi"
#include once "iupdef.bi"

#ifndef NULL
#define NULL cptr(any ptr,0)
#endif

#if defined(__FB_WIN32__)
 #inclib "gdi32"
 #inclib "user32"
 #inclib "comdlg32"
 #inclib "comctl32"
 #inclib "shell32"
 #inclib "advapi32"
 #inclib "ole32"
 #inclib "uuid" ' since  3.7
 #ifndef IUP_DLL
  #libpath "lib/win32/"
 #else
  #libpath "lib/win32dll/"
 #endif
#else
 #inclib "gtk-x11-2.0"
 #inclib "gdk-x11-2.0"
 #inclib "pangox-1.0"
 #inclib "gdk_pixbuf-2.0"
 #inclib "pango-1.0"
 #inclib "gobject-2.0"
 #inclib "gmodule-2.0"
 #inclib "glib-2.0"
 #libpath "lib/linux/"
#endif

#inclib "iup"

#define IUP_NAME "IUP - Portable User Interface"
#define IUP_COPYRIGHT "Copyright (C) 1994-2011 Tecgraf, PUC-Rio."
#define IUP_DESCRIPTION "Portable toolkit for building graphical user interfaces."
#define IUP_VERSION "3.5"
#define IUP_VERSION_NUMBER 305000
#define IUP_VERSION_DATE "2011/04/26"


'************************************************************************
'*                   Record Input Modes                                 *
'************************************************************************
enum RecordMode
  IUP_RECBINARY
  IUP_RECTEXT
end enum

type Ihandle as any
type PIHandle as IHandle ptr

type ICALLBACK as function cdecl(ih as IHandle ptr) as integer
type IPARAMCB as function cdecl(ih as IHandle ptr, as integer, p as any ptr) as integer

extern "C"

'***********************************************************************
'*                        Main API                                     *
'***********************************************************************
_DF_ IupOpen(argc as integer ptr, argv as byte ptr ptr ptr) as integer
_DS_ IupClose()

_DS_ IupImageLibOpen()

_DF_ IupMainLoop() as integer
_DF_ IupLoopStep() as integer
_DF_ IupLoopStepWait() as integer
_DF_ IupMainLoopLevel() as integer
_DS_ IupFlush()
_DS_ IupExitLoop()

_DF_ IupRecordInput(filename as const zstring ptr, mode as RecordMode) as integer
_DF_ IupPlayInput  (filename as const zstring ptr) as integer

_DS_ IupUpdate(ih as IHandle ptr)
_DS_ IupUpdateChildren(ih as IHandle ptr)
_DS_ IupRedraw(ih as IHandle ptr, children as integer)
_DS_ IupRefresh(ih as IHandle ptr)
_DS_ IupRefreshChildren(ih as IHandle ptr)

' font
_DF_ IupMapFont(iupfont as const zstring ptr) as zstring ptr
_DF_ IupUnMapFont(driverfont as const zstring ptr) as zstring ptr

_DF_ IupHelp(url as const zstring ptr) as integer
' layout
_DF_ IupLoad(filename as const zstring ptr) as zstring ptr
_DF_ IupLoadBuffer(buffer as const zstring ptr) as zstring ptr

_DF_ IupVersion() as zstring ptr
_DF_ IupVersionDate() as zstring ptr
_DF_ IupVersionNumber() as integer
_DS_ IupSetLanguage(lng as zstring ptr)
_DF_ IupGetLanguage() as zstring ptr

_DS_ IupDestroy       (ih as IHandle ptr)
_DS_ IupDetach        (child as IHandle ptr)
_DF_ IupAppend        (ih as IHandle ptr, child as IHandle ptr) as IHandle ptr
_DF_ IupInsert        (ih as IHandle ptr, ref_child as IHandle ptr, child as IHandle ptr) as IHandle ptr
_DF_ IupGetChild      (ih as IHandle ptr, pos_ as integer) as IHandle ptr
_DF_ IupGetChildPos   (ih as IHandle ptr, child as IHandle ptr) as integer
_DF_ IupGetChildCount (ih as IHandle ptr) as integer
_DF_ IupGetNextChild  (ih as IHandle ptr, child as IHandle ptr) as IHandle ptr
_DF_ IupGetBrother    (ih as IHandle ptr) as IHandle ptr
_DF_ IupGetParent     (ih as IHandle ptr) as IHandle ptr
_DF_ IupGetDialog     (ih as IHandle ptr) as IHandle ptr
_DF_ IupGetDialogChild(ih as IHandle ptr, name_ as zstring ptr) as IHandle ptr
_DF_ IupReparent      (ih as IHandle ptr, new_parent as IHandle ptr, ref_child as IHandle ptr) as integer

_DF_ IupPopup (ih as IHandle ptr, x as integer, y as integer) as integer
_DF_ IupShow  (ih as IHandle ptr) as integer
_DF_ IupShowXY(ih as IHandle ptr, x as integer, y as integer) as integer
_DF_ IupHide  (ih as IHandle ptr) as integer
_DF_ IupMap   (ih as IHandle ptr) as integer
_DS_ IupUnmap (ih as IHandle ptr)

_DS_ IupSetAttribute    (ih as IHandle ptr, name_ as const zstring ptr, value as const zstring ptr)
_DS_ IupStoreAttribute  (ih as IHandle ptr, name_ as const zstring ptr, value as const zstring ptr)
_DF_ IupSetAttributes   (ih as IHandle ptr, str_  as const zstring ptr) as IHandle ptr
_DF_ IupGetAttribute    (ih as IHandle ptr, name_ as const zstring ptr) as zstring ptr
_DF_ IupGetAttributes   (ih as IHandle ptr) as zstring ptr
_DF_ IupGetInt          (ih as IHandle ptr, name_ as const zstring ptr) as integer
_DF_ IupGetInt2         (ih as IHandle ptr, name_ as const zstring ptr) as integer
_DF_ IupGetIntInt       (ih as IHandle ptr, name_ as const zstring ptr, i1 as integer ptr, i2 as integer ptr) as integer
_DF_ IupGetFloat        (ih as IHandle ptr, name_ as const zstring ptr) as single
_DS_ IupSetfAttribute   (ih as IHandle ptr, name_ as const zstring ptr, format_ as const zstring ptr, ...)
_DS_ IupResetAttribute  (ih as IHandle ptr, name_ as const zstring ptr)
_DF_ IupGetAllAttributes(ih as IHandle ptr, names as zstring ptr ptr, n as integer) as integer
_DF_ IupSetAtt(handle_name as const zstring ptr, ih as IHandle ptr, name_ as const zstring ptr, ...) as IHandle ptr

_DS_ IupSetAttributeId  (ih as IHandle ptr, name_ as const zstring ptr, id as integer, value as const zstring ptr)
_DS_ IupStoreAttributeId(ih as IHandle ptr, name_ as const zstring ptr, id as integer, value as const zstring ptr)
_DF_ IupGetAttributeId  (ih as IHandle ptr, name_ as const zstring ptr, id as integer) as zstring ptr
_DF_ IupGetFloatId      (ih as IHandle ptr, name_ as const zstring ptr, id as integer) as single
_DF_ IupGetIntId        (ih as IHandle ptr, name_ as const zstring ptr, id as integer) as integer
_DS_ IupSetfAttributeId (ih as IHandle ptr, name_ as const zstring ptr, id as integer, format_ as zstring ptr, ...)

_DS_ IupSetAttributeId2  (ih as IHandle ptr, name_ as const zstring ptr, lin as integer, col as integer, value as zstring ptr)
_DS_ IupStoreAttributeId2(ih as IHandle ptr, name_ as const zstring ptr, lin as integer, col as integer, value as zstring ptr)
_DF_ IupGetAttributeId2  (ih as IHandle ptr, name_ as const zstring ptr, lin as integer, col as integer) as zstring ptr
_DF_ IupGetIntId2        (ih as IHandle ptr, name_ as const zstring ptr, lin as integer, col as integer) as integer
_DF_ IupGetFloatId2      (ih as IHandle ptr, name_ as const zstring ptr, lin as integer, col as integer) as single
_DS_ IupSetfAttributeId2 (ih as IHandle ptr, name_ as const zstring ptr, lin as integer, col as integer, format_ as const zstring ptr, ...)

_DS_ IupSetGlobal  (name_ as const zstring ptr, value as const zstring ptr)
_DS_ IupStoreGlobal(name_ as const zstring ptr, value as const zstring ptr)
_DF_ IupGetGlobal  (name_ as const zstring ptr) as zstring ptr

_DF_ IupSetFocus     (ih as IHandle ptr) as IHandle ptr
_DF_ IupGetFocus     () as IHandle ptr
_DF_ IupPreviousField(ih as IHandle ptr) as IHandle ptr
_DF_ IupNextField    (ih as IHandle ptr) as IHandle ptr

_DF_ IupGetCallback (ih as IHandle ptr, name_ as const zstring ptr) as ICALLBACK
_DF_ IupSetCallback (ih as IHandle ptr, name_ as const zstring ptr, func as ICALLBACK) as ICALLBACK
_DF_ IupSetCallbacks(ih as IHandle ptr, name_ as const zstring ptr, func as ICALLBACK, ...) as IHandle ptr

_DF_ IupGetFunction  (name_ as const zstring ptr) as ICALLBACK
_DF_ IupSetFunction  (name_ as const zstring ptr, func as ICALLBACK) as ICALLBACK
_DF_ IupGetActionName() as zstring ptr

_DF_ IupGetHandle    (name_ as const zstring ptr) as IHandle ptr
_DF_ IupSetHandle    (name_ as const zstring ptr, ih as IHandle ptr) as IHandle ptr
_DF_ IupGetAllNames  (names as zstring ptr ptr, n as integer) as integer
_DF_ IupGetAllDialogs(names as zstring ptr ptr, n as integer) as integer
_DF_ IupGetName      (ih as IHandle ptr) as zstring ptr

_DS_ IupSetAttributeHandle(ih as IHandle ptr, name_ as const zstring ptr, ih_named as IHandle ptr)
_DF_ IupGetAttributeHandle(ih as IHandle ptr, name_ as const zstring ptr) as IHandle ptr

_DF_ IupGetClassName  (ih as IHandle ptr) as zstring ptr
_DF_ IupGetClassType  (ih as IHandle ptr) as zstring ptr
_DF_ IupGetAllClasses  (names as zstring ptr ptr, n as integer) as integer
_DF_ IupGetClassAttributes (classname as const zstring ptr, names as zstring ptr ptr, n as integer) as integer
_DF_ IupGetClassCallbacks  (classname as const zstring ptr, names as zstring ptr ptr, n as integer) as integer
_DS_ IupSaveClassAttributes  (ih as IHandle ptr)
_DS_ IupCopyClassAttributes  (src_ih as IHandle ptr, dst_ih as IHandle ptr)
_DS_ IupSetClassDefaultAttribute  (classname as const zstring ptr, name_ as const zstring ptr, value as const zstring ptr)
_DF_ IupClassMatch  (ih as IHandle ptr, classname as const zstring ptr) as integer

_DF_ IupCreate (classname as const zstring ptr) as IHandle ptr
_DF_ IupCreatev(classname as const zstring ptr, params as any ptr ptr) as IHandle ptr
_DF_ IupCreatep(classname as const zstring ptr, first as any ptr, ...) as IHandle ptr

'***********************************************************************
'*                        Elements                                     *
'***********************************************************************
_DF_ IupFill  () as IHandle ptr
_DF_ IupRadio (child as IHandle ptr) as IHandle ptr
_DF_ IupVbox  (child as IHandle ptr, ...) as IHandle ptr
_DF_ IupVboxv (children as IHandle ptr ptr) as IHandle ptr
_DF_ IupZbox  (child as IHandle ptr, ...) as IHandle ptr
_DF_ IupZboxv (children as IHandle ptr ptr) as IHandle ptr
_DF_ IupHbox  (child as IHandle ptr, ...) as IHandle ptr
_DF_ IupHboxv (children as IHandle ptr ptr) as IHandle ptr

_DF_ IupNormalizer (ih_first as IHandle ptr, ...) as IHandle ptr
_DF_ IupNormalizerv(ih_list as IHandle ptr ptr) as IHandle ptr

_DF_ IupCbox  (child as IHandle ptr, ...) as IHandle ptr
_DF_ IupCboxv (children as IHandle ptr ptr) as IHandle ptr
_DF_ IupSbox  (child as IHandle ptr) as IHandle ptr
_DF_ IupSplit (child1 as IHandle ptr, child2 as IHandle ptr) as IHandle ptr

_DF_ IupFrame  (child as IHandle ptr) as IHandle ptr

_DF_ IupScrollBox(child as IHandle ptr) as IHandle ptr

_DF_ IupImage     (w as integer, h as integer, pixmap as const ubyte ptr) as IHandle ptr
_DF_ IupImageRGB  (w as integer, h as integer, pixmap as const ubyte ptr) as IHandle ptr
_DF_ IupImageRGBA (w as integer, h as integer, pixmap as const ubyte ptr) as IHandle ptr

_DF_ IupItem   (title as const zstring ptr, action as const zstring ptr) as IHandle ptr
_DF_ IupSubmenu(title as const zstring ptr, child  as IHandle ptr) as IHandle ptr
_DF_ IupSeparator() as IHandle ptr
_DF_ IupMenu   (child as IHandle ptr, ...) as IHandle ptr
_DF_ IupMenuv  (children as IHandle ptr ptr) as IHandle ptr

_DF_ IupButton (title as const zstring ptr, action as const zstring ptr) as IHandle ptr
_DF_ IupCanvas (action as const zstring ptr) as IHandle ptr
_DF_ IupDialog (child as IHandle ptr) as IHandle ptr
_DF_ IupUser() as IHandle ptr
_DF_ IupLabel(title as const zstring ptr) as IHandle ptr
_DF_ IupList(action as const zstring ptr) as IHandle ptr
_DF_ IupText(action as const zstring ptr) as IHandle ptr
' Deprecated use IupText() with attribute "MULTILINE=YES"
_DF_ IupMultiLine(action as const string ptr) as IHandle ptr
_DF_ IupToggle(title as const zstring ptr, action as const zstring ptr) as IHandle ptr
_DF_ IupTimer() as IHandle ptr
_DF_ IupClipboard() as IHandle ptr
_DF_ IupProgressBar() as IHandle ptr
_DF_ IupVal(type_ as const zstring ptr) as IHandle ptr
_DF_ IupTabs(child as IHandle ptr, ...) as IHandle ptr
_DF_ IupTabsv(children as IHandle ptr ptr) as IHandle ptr
_DF_ IupTree() as IHandle ptr

' Deprecated controls use SPIN attribute of IupText
_DF_ IupSpin   () as IHandle ptr
_DF_ IupSpinbox(child as IHandle ptr) as IHandle ptr

' IupImage utility
_DF_ IupSaveImageAsText(ih as IHandle ptr, file_name as const zstring ptr, format_ as const zstring ptr, name_ as const zstring ptr) as integer

' IupText utilities
_DS_ IupTextConvertLinColToPos(ih as IHandle ptr, lin as integer, col as integer, pos as integer ptr)
_DS_ IupTextConvertPosToLinCol(ih as IHandle ptr, pos_ as integer, lin as integer ptr, col as integer ptr)

' IupText, IupList and IupTree utility
_DF_ IupConvertXYToPos(ih as IHandle ptr, x as integer, y as integer) as integer

' IupTree utilities
_DF_ IupTreeSetUserId(ih as IHandle ptr, id as integer, userid as any ptr) as integer
_DF_ IupTreeGetUserId(ih as IHandle ptr, id as integer) as any ptr
_DF_ IupTreeGetId    (ih as IHandle ptr, userid as any ptr) as integer

' Deprecated IupTree utilities, use Iup*AttributeId functions
_DS_ IupTreeSetAttribute      (ih as IHandle ptr, name_ as const zstring ptr, id as integer, value as const zstring ptr)
_DS_ IupTreeStoreAttribute    (ih as IHandle ptr, name_ as const zstring ptr, id as integer, value as const zstring ptr)
_DF_ IupTreeGetAttribute      (ih as IHandle ptr, name_ as const zstring ptr, id as integer) as zstring ptr
_DF_ IupTreeGetInt            (ih as IHandle ptr, name_ as const zstring ptr, id as integer) as integer
_DF_ IupTreeGetFloat          (ih as IHandle ptr, name_ as const zstring ptr, id as integer) as single
_DS_ IupTreeSetfAttribute     (ih as IHandle ptr, name_ as const zstring ptr, id as integer, format_ as zstring ptr, ...)
_DS_ IupTreeSetAttributeHandle(ih as IHandle ptr, a as const zstring ptr, id as integer, ih_named as IHandle ptr)

'************************************************************************
'*                      Pre-definided dialogs                           *
'************************************************************************

_DF_ IupFileDlg   () as IHandle ptr
_DF_ IupMessageDlg() as IHandle ptr
_DF_ IupColorDlg  () as IHandle ptr
_DF_ IupFontDlg   () as IHandle ptr

_DF_ IupGetFile  (arq as zstring ptr) as integer
_DS_ IupMessage  (title as const zstring ptr, msg as const zstring ptr)
_DS_ IupMessagef (title as const zstring ptr, format_ as const zstring ptr, ...)
_DF_ IupAlarm    (title as const zstring ptr, msg as const zstring ptr, b1 as const zstring ptr, b2 as const zstring ptr, b3 as const zstring ptr) as integer
_DF_ IupScanf    (format_ as const zstring ptr, ...) as integer
_DF_ IupListDialog(type_ as integer, title as const zstring ptr, size as integer, list as const zstring ptr ptr, op as integer, max_col as integer, max_lin as integer, marks as integer ptr) as integer
_DF_ IupGetText   (title as const zstring ptr, text as zstring ptr) as integer
_DF_ IupGetColor  (x as integer, y as integer, r as ubyte ptr, g as ubyte ptr, b as ubyte ptr) as integer

_DF_ IupGetParam  (title as const zstring ptr, action as IPARAMCB, user_data as any ptr, format_ as const zstring ptr, ...) as integer
_DF_ IupGetParamv (title as const zstring ptr, action as IPARAMCB, user_data as any ptr, format_ as const zstring ptr, param_count as integer, param_extra as integer, param_data as any ptr ptr) as integer

_DF_ IupLayoutDialog  (dialog as IHandle ptr) as IHandle ptr
_DF_ IupElementPropertiesDialog(elem as IHandle ptr) as IHandle ptr

end extern

'************************************************************************
'*                   Common Return Values                               *
'************************************************************************
#define IUP_ERROR 1
#define IUP_NOERROR 0
#define IUP_OPENED -1
#define IUP_INVALID -1

'************************************************************************
'*                   Callback Return Values                             *
'************************************************************************
#define IUP_IGNORE -1
#define IUP_DEFAULT -2
#define IUP_CLOSE -3
#define IUP_CONTINUE -4

'************************************************************************
'*           IupPopup and IupShowXY Parameter Values                    *
'************************************************************************
#define IUP_CENTERPARENT &hFFFA
#define IUP_CURRENT      &hFFFB
#define IUP_MOUSEPOS     &hFFFC
#define IUP_BOTTOM       &hFFFD
#define IUP_RIGHT        &hFFFD
#define IUP_TOP          &hFFFE
#define IUP_LEFT         &hFFFE
#define IUP_CENTER       &hFFFF

'************************************************************************
'*               SHOW_CB Callback Values                                *
'************************************************************************
enum
  IUP_SHOW
  IUP_RESTORE
  IUP_MINIMIZE
  IUP_MAXIMIZE
  IUP_HIDE
end enum

'************************************************************************
'*               SCROLL_CB Callback Values                              *
'************************************************************************
enum
  IUP_SBUP
  IUP_SBDN
  IUP_SBPGUP
  IUP_SBPGDN
  IUP_SBPOSV
  IUP_SBDRAGV
  IUP_SBLEFT
  IUP_SBRIGHT
  IUP_SBPGLEFT
  IUP_SBPGRIGHT
  IUP_SBPOSH
  IUP_SBDRAGH
end enum

'************************************************************************
'*               Mouse Button Values and Macros                         *
'************************************************************************
#define IUP_BUTTON1 asc("1")
#define IUP_BUTTON2 asc("2")
#define IUP_BUTTON3 asc("3")
#define IUP_BUTTON4 asc("4")
#define IUP_BUTTON5 asc("5")

#define iup_isshift(_s)    (_s[0]=asc("S"))
#define iup_iscontrol(_s)  (_s[1]=asc("C"))
#define iup_isbutton1(_s)  (_s[2]=asc("1"))
#define iup_isbutton2(_s)  (_s[3]=asc("2"))
#define iup_isbutton3(_s)  (_s[4]=asc("3"))
#define iup_isdouble(_s)   (_s[5]=asc("D"))
#define iup_isalt(_s)      (_s[6]=asc("A"))
#define iup_issys(_s)      (_s[7]=asc("Y"))
#define iup_isbutton4(_s)  (_s[8]=asc("4"))
#define iup_isbutton5(_s)  (_s[9]=asc("5"))

' Old definitions for backward compatibility
#define isshift     iup_isshift
#define iscontrol   iup_iscontrol
#define isbutton1   iup_isbutton1
#define isbutton2   iup_isbutton2
#define isbutton3   iup_isbutton3
#define isdouble    iup_isdouble
#define isalt       iup_isalt
#define issys       iup_issys
#define isbutton4   iup_isbutton4
#define isbutton5   iup_isbutton5

'************************************************************************
'*                      Pre-Defined Masks                               *
'************************************************************************
#define IUP_MASK_FLOAT "[+/-]?(/d+/.?/d*|/./d+)"
#define IUP_MASK_UFLOAT "(/d+/.?/d*|/./d+)"
#define IUP_MASK_EFLOAT "[+/-]?(/d+/.?/d*|/./d+)([eE][+/-]?/d+)?"
#define IUP_MASK_INT "[+/-]?/d+"
#define IUP_MASK_UINT "/d+"

' Old definitions for backward compatibility
#define IUPMASK_FLOAT IUP_MASK_FLOAT
#define IUPMASK_UFLOAT IUP_MASK_UFLOAT
#define IUPMASK_EFLOAT IUP_MASK_EFLOAT
#define IUPMASK_INT IUP_MASK_INT
#define IUPMASK_UINT IUP_MASK_UINT

#endif



