#ifndef __IUP_CHILDTREE_OPT_BI__
#define __IUP_CHILDTREE_OPT_BI__

' see copyright notice at the file iup.txt

' optional

#include once "iup_object_opt.bi"

extern "c"

' Child Tree Utilities
' Some native containers have an internal native child that 
' will be the actual container for the children. This native container is 
' returned by iupClassObjectGetInnerNativeContainerHandle and
' it is used in iupChildTreeGetNativeParentHandle.
' Some native elements need an extra parent, the ih->handle points to the main element itself, 
' NOT to the extra parent. This extra parent is stored as "_IUP_EXTRAPARENT". 
' In this case the native parent of ih->handle is the extra parent, 
' and the extra parent is added as child to the element native parent.

' Returns the native parent. It simply excludes containers that are from IUP_TYPEVOID classes.
_DF_ iupChildTreeGetNativeParent(ih as Ihandle ptr) as Ihandle ptr

' Returns the native parent handle. Uses iupChildTreeGetNativeParent and \ref iupClassObjectGetInnerNativeContainerHandle.
_DF_ iupChildTreeGetNativeParentHandle(ih as Ihandle ptr) as InativeHandle ptr

' Adds the child directly to the parent tree.
_DS_ iupChildTreeAppend(parent as Ihandle ptr, child as Ihandle ptr)

' Checks if the child belongs to the parent tree.
'_DF_ iupChildTreeIsChild(ih as Ihandle ptr, child as Ihandle ptr) as integer

' Returns the previous brother if any.
'_DF_ iupChildTreeGetPrevBrother(Ihandle* ih as Ihandle ptr) as  as Ihandle ptr

end extern

/' Other functions declared in iup.bi and implemented here. 
IupGetDialog
IupDetach
IupAppend
IupGetChild
IupGetNextChild
IupGetBrother
IupGetParent
'/

#endif ' __IUP_CHILDTREE_OPT_BI__
