#ifndef __IUP_DLGLIST_OPT_BI__
#define __IUP_DLGLIST_OPT_BI__

' see copyright notice at the file iup.txt

' optional

#include once "iup.bi"

extern "c"

' List of Dialogs

' Adds a dialog to the list. Used only in IupDialog.
_DS_ iupDlgListAdd(ih as IHandle ptr)

' Removes a dialog from the list. Used only in IupDestroy.
_DS_ iupDlgListRemove(ih as IHandle ptr)

' Returns the number of dialogs.
_DF_ iupDlgListCount() as integer

' Starts a loop for all the created dialogs. 
_DF_ iupDlgListFirst() as IHandle ptr

' Retrieve the next dialog on the list. Must call iupDlgListFirst first.
_DF_ iupDlgListNext() as IHandle ptr

' Increments the number of visible dialogs. 
_DS_ iupDlgListVisibleInc()

' Decrements the number of visible dialogs.
_DS_ iupDlgListVisibleDec()

' Returns the number of visible dialogs.
_DF_ iupDlgListVisibleCount() as integer

' Destroy all dialogs and the list.
' Called only from IupClose.
_DS_ iupDlgListDestroyAll()

end extern


#endif ' __IUP_DLGLIST_OPT_BI__
