#ifndef __IUP_DRV_OPT_BI__
#define __IUP_DRV_OPT_BI__

' see copyright notice at the file iup.txt

' optional 

extern "c"
  
' Driver Interface 
' Each driver must export the symbols defined here.

' Sets a global environment attribute. Called from IupSetGlobal and IupStoreGlobal.
' Must return 1 is process the atribute, or 0 is not. 
'int iupdrvSetGlobal(const char* name, const char* value);

' Returns a global environment attribute. Called from IupGetGlobal.
'char* iupdrvGetGlobal(const char* name);

' Changes the idle callback. Called from IupSetFunction.
'void iupdrvSetIdleFunction(Icallback func);

' Convert the coordinates from screen relative to client area.
_DS_ iupdrvScreenToClient(ih as Ihandle ptr, x as integer ptr, y as integer ptr)

' Convert the coordinates from relative client area to screen.
_DS_ iupdrvClientToScreen(ih as Ihandle ptr, x as integer ptr,y as integer ptr)

' Returns true if the element is visible.
_DF_ iupdrvIsVisible(ih as Ihandle ptr) as integer

' Returns true if the element is active.
_DF_ iupdrvIsActive(ih as Ihandle ptr) as integer

' Actually changes the focus to the given element.
'void iupdrvSetFocus(ih as Ihandle ptr);

' Changes the visible state of an element. Not used for dialogs. 
_DS_ iupdrvSetVisible(ih as Ihandle ptr, enable as integer)

' Changes the active state of an element. 
_DS_ iupdrvSetActive(ih as Ihandle ptr, enable as integer) 

' Post a redraw of a control.
_DS_ iupdrvPostRedraw(ih as Ihandle ptr)

' Force a redraw of a control.
_DS_ iupdrvRedrawNow(ih as Ihandle ptr)

' Reparent the native control.
_DS_ iupdrvReparent(ih as Ihandle ptr)

' Draws a focus rectangle
_DS_ iupdrvDrawFocusRect(ih as Ihandle ptr, gc as any ptr, x as integer, y as integer, w as integer, h as integer)

' Size of the scroolbar.
_DF_ iupdrvGetScrollbarSize() as integer

' Activates a control.
'void iupdrvActivate(ih as Ihandle ptr)

' Returns the height of a menu bar.
'int iupdrvMenuGetMenuBarSize(ih as Ihandle ptr)

' Sends a global keyboard message.
_DS_ iupdrvSendKey(key as integer, press as integer)

' Sends a global mouse message.
' status: 2=double pressed, 1=pressed, 0=released, -1=move
_DS_ iupdrvSendMouse(x as integer, y as integer, bt as integer, status as integer)

' Moves the cursor on screen.
_DS_ iupdrvWarpPointer(x as integer, y as integer)

' Supends execution for the specified number of miliseconds.
'void iupdrvSleep(time as integer)

' Called only from IupOpen/IupClose.
'int iupdrvOpen(int *argc, char ***argv);
'void iupdrvClose(void);

end extern

#endif
