#ifndef __IUP_DRVFONT_OPT_BI__
#define __IUP_DRVFONT_OPT_BI__

' see copyright notice at the file iup.txt

' optional

extern "c"

' Driver Font Interface 
' Each driver must export the symbols defined here.

' Called only from IupOpen/IupClose.
'void iupdrvFontInit()
'void iupdrvFontFinish()

' Retrieve the character size for the selected font.
' Should be used only to calculate the SIZE attribute.
_DS_ iupdrvFontGetCharSize(ih as Ihandle ptr, charwidth as integer ptr, charheight as integer ptr)

' Retrieve the string width for the selected font.
_DF_ iupdrvFontGetStringWidth(ih as Ihandle ptr, str_ as const zstring ptr) as integer

' Retrieve the multi-lined string size for the selected font.
' Width is the maximum line width.
' Height is charheight*number_of_lines (this will avoid line size variations).
_DS_ iupdrvFontGetMultiLineStringSize(ih as Ihandle ptr, str_ as const zstring ptr, w as integer ptr, h as integer ptr)

' Returns the System default font.
_DF_ iupdrvGetSystemFont() as zstring ptr

' STANDARDFONT attribute set function.
_DF_ iupdrvSetStandardFontAttrib(ih as Ihandle ptr, value as const zstring ptr) as integer

' FONT attribute get function.
_DF_ iupGetFontAttrib(ih as Ihandle ptr) as zstring ptr

' FONT attribute set function.
_DF_ iupSetFontAttrib(ih as Ihandle ptr, value as const zstring ptr) as integer

' Parse the font format description.
' Returns a non zero value if successful.
'int iupGetFontInfo(const char* standardfont, char *fontface, int *size, int *is_bold, int *is_italic, int *is_underline, int *is_strikeout);

' Parse the Pango font format description.
' Returns a non zero value if successful.
_DF_ iupFontParsePango(value as const zstring ptr, _
                       fontface as zstring ptr, _
                       size as integer ptr, _
                       bold as integer ptr, _
                       italic as integer ptr, _
                       underline as integer ptr, _
                       strikeout as integer ptr) as integer

' Parse the old IUP Windows font format description.
' Returns a non zero value if successful.
_DF_ iupFontParseWin  (value as const zstring ptr, _
                       fontface as zstring ptr, _
                       size as integer ptr, _
                       bold as integer ptr, _
                       italic as integer ptr, _
                       underline as integer ptr, _
                       strikeout as integer ptr) as integer

' Parse the X-Windows font format description.
' Returns a non zero value if successful.
_DF_ iupFontParseX    (value as const zstring ptr, _
                       fontface as zstring ptr, _
                       size as integer ptr, _
                       bold as integer ptr, _
                       italic as integer ptr, _
                       underline as integer ptr, _
                       strikeout as integer ptr) as integer

' Changes the FONT style only.
_DF_ iupSetFontStyleAttrib(ih as Ihandle ptr, value as const zstring ptr) as integer

' Changes the FONT size only.
_DF_ iupSetFontSizeAttrib(ih as Ihandle ptr, value as const zstring ptr) as integer

' Returns the FONT style.
_DF_ iupGetFontStyleAttrib(ih as Ihandle ptr) as zstring ptr

' Returns the FONT size.
_DF_ iupGetFontSizeAttrib(ih as Ihandle ptr) as zstring ptr

' Returns the FONT face.
_DF_ iupGetFontFaceAttrib(ih as Ihandle ptr) as zstring ptr

' Used in GLobal Attributes
'void iupSetDefaultFontSizeGlobalAttrib(value as const zstring ptr);
'char* iupGetDefaultFontSizeGlobalAttrib();


' Updates the STANDARDFONT attrib.
'void iupUpdateStandardFontAttrib(ih as Ihandle ptr);

' Used to map foreign names into native names
'const char* iupFontGetWinName(const char* name);
'const char* iupFontGetXName(const char* name);
'const char* iupFontGetPangoName(const char* name);

end extern


#endif ' __IUP_DRVFONT_OPT_BI__

