#ifndef __IUP_DRVINFO_OPT_BI__ 
#define __IUP_DRVINFO_OPT_BI__

' see copyright notice at the file iup.txt

' optional

extern "c"

' Driver Information Interface 
' Each driver must export the symbols defined here. 
' But in this case the functions are shared by different drivers in the same system.
' For example, the GTK driver and the Windows driver share the same implementation 
' of these functions when the GTK driver is compiled in Windows. 
' The GTK driver and the Motif driver share the same implementation 
' of these functions when the GTK driver is compiled in UNIX. 

' Retrieve the main desktop full size.
_DS_ iupdrvGetFullSize(w as integer ptr, h as integer ptr)

' Retrieve the main desktop available size.
_DS_ iupdrvGetScreenSize(w as integer ptr, h as integer ptr)

' Retrieve the main desktop size when there are multiple monitors.
' Useful only when in GTK.
'int iupdrvCheckMainScreen(int *width, int *height);

' Retrieve the default desktop bits per pixel.
_DF_ iupdrvGetScreenDepth() as integer

' Returns a string with the system version number.
_DF_ iupdrvGetSystemVersion() as zstring ptr

' Returns a string with the system name.
_DF_ iupdrvGetSystemName() as zstring ptr

' Returns a string with the computer name.
_DF_ iupdrvGetComputerName() as zstring ptr

' Returns a string with the user name.
_DF_ iupdrvGetUserName() as zstring ptr

' Returns the key state for Shift, Ctrl, Alt and sYs, in this order.
' Left and right keys are considered.
' Should declare "char key[5]".
' Values could be space (" ") or "SCAY".
_DS_ iupdrvGetKeyState(key as zstring ptr)

' Returns the current position of the mouse cursor.
_DS_ iupdrvGetCursorPos(x as integer ptr, y as integer ptr)

' Returns the driver "Display" in UNIX and NULL in Windows.
_DF_ iupdrvGetDisplay() as any ptr

' Returns the current directory.
_DF_ iupdrvGetCurrentDirectory() as zstring ptr

' Changes the current directory.
_DF_ iupdrvSetCurrentDirectory(dir_ as const zstring ptr) as integer

' Returns true if the given name is an existant file.
_DF_ iupdrvIsFile(name_ as const zstring ptr) as integer

' Returns true if the given name is an existant directory.
_DF_ iupdrvIsDirectory(name_ as const zstring ptr) as integer

' Creates a new direcotry.
_DF_ iupdrvMakeDirectory(name_ as const zstring ptr) as integer

' Returns the current locale name.
_DF_ iupdrvLocaleInfo() as zstring ptr


end extern

#endif ' __IUP_DRVINFO_OPT_BI__
