#ifndef __IUP_IMAGE_OPT_BI__
#define __IUP_IMAGE_OPT_BI__

' see copyright notice at the file iup.txt

' optional

enum 
  IUPIMAGE_IMAGE
  IUPIMAGE_ICON
  IUPIMAGE_CURSOR
end enum

type iupColor 
  as ubyte r, g, b, a
end type

type iupImageStockCreateFunc as function cdecl () as Ihandle ptr

#define iupALPHABLEND(_src,_dst,_alpha) cubyte(((_src) * (_alpha) + (_dst) * (255 - (_alpha))) / 255)

extern "C"

' In Windows, RAW data is a DIB handle. 
' imgdata here is bottom-up arranged and has separated planes
_DF_ iupdrvImageCreateImageRaw(w as integer, h as integer, bpp as integer, colors as iupColor ptr, colors_count as integer, imgdata as ubyte ptr) as any ptr
_DF_ iupdrvImageGetRawInfo(handle as any ptr, w as integer ptr, h as integer ptr, bpp as integer ptr, colors as iupColor ptr, colors_count as integer ptr) as integer
_DS_ iupdrvImageGetRawData(handle as any ptr, imgdata as ubyte ptr)
_DS_ iupdrvImageDestroy   (handle as any ptr, typ as integer)

_DS_ iupImageColorMakeInactive(r as ubyte ptr, g as ubyte ptr, b as ubyte ptr, _
                               bg_r as ubyte, bg_g as ubyte, bg_b as ubyte)

_DS_ iupImageStockSet(name_ as const zstring ptr, func as iupImageStockCreateFunc, native_name as const zstring ptr)
' Used only in iupImageLibLoadAll
_DS_ iupImageStockLoad(name_ as const zstring ptr) 

end extern

'void* iupdrvImageCreateMask(ih as Ihandle ptr) as any ptr
'void* iupdrvImageCreateIcon(ih as Ihandle ptr) as any ptr
'void* iupdrvImageCreateCursor(ih as Ihandle ptr) as any ptr
'void* iupdrvImageCreateImage(ih as Ihandle ptr, const char* bgcolor, int make_inactive) as any ptr
'void* iupdrvImageLoad(const char* name, int type) as any ptr
' only for IUPIMAGE_IMAGE
'int   iupdrvImageGetInfo(void* handle, int *w, int *h, int *bpp)
'void* iupImageGetMask(const char* name);
'void* iupImageGetIcon(const char* name);
'void* iupImageGetCursor(const char* name);
'void* iupImageGetImage(const char* name, Ihandle* parent, int make_inactive);
'void iupImageGetInfo(const char* name, int *w, int *h, int *bpp);
'void iupImageUpdateParent(Ihandle *parent);
'void iupImageClearCache(Ihandle* ih, void* handle);
'int iupImageInitColorTable(ih as Ihandle ptr, iupColor* colors, int *colors_count);
'void iupImageInitNonBgColors(Ihandle* ih, unsigned char *colors);
'int iupImageNormBpp(int bpp);
'void iupImageStockInit(void);
'void iupImageStockFinish(void);



#endif ' __IUP_IMAGE_OPT_BI__
