#ifndef __IUP_MASK_OPT_BI__ 
#define __IUP_MASK_OPT_BI__

' see copyright notice at the file iup.txt

' optional

extern "c"

' Text Mask
' Used to filter text input in IupText.

type _Imask as any : type Imask as _Imask

' Creates a mask given a string.
' If casei is true, will turn the mask case insensitive.
_DF_ iupMaskCreate(mask_str as const zstring ptr , casei as integer) as Imask ptr

' Creates an integer mask with limits.
_DF_ iupMaskCreateInt(min as integer, max as integer) as Imask ptr

' Creates a float mask with limits.
_DF_ iupMaskCreateFloat(min as single, max as single) as Imask ptr

' Destroys the mask.
_DS_ iupMaskDestroy(mask as Imask ptr)

' Check if the value is valid using the mask to filter it.
' Returns 1 if full match, -1 if partial match, and 0 otherwise.
_DF_ iupMaskCheck( mask as Imask ptr, value as const zstring ptr) as integer

' Returns the mask string.
'_DF_* iupMaskGetStr(mask as Imask ptr) as zstring ptr
end extern

#endif ' __IUP_MASK_OPT_BI__
