#ifndef __WD_BI__
#define __WD_BI__

#include once "cd.bi"

type draw_func as sub cdecl (canvas_copy as cdCanvas ptr)

extern "c"


' coordinate transformation
_DS_ wdCanvasWindow(cnv as cdCanvas ptr, xmin as double, xmax as double, ymin as double, ymax as double)
_DS_ wdCanvasGetWindow(cnv as cdCanvas ptr, xmin as double ptr, xmax as double ptr, ymin as double ptr, ymax as double ptr)
_DS_ wdCanvasViewport(cnv as cdCanvas ptr, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ wdCanvasGetViewport(cnv as cdCanvas ptr, xmin as integer ptr, xmax as integer ptr, ymin as integer ptr, ymax as integer ptr)
_DS_ wdCanvasWorld2Canvas(cnv as cdCanvas ptr, xw as double, yw as double, xv as integer ptr, yv as integer ptr)
_DS_ wdCanvasWorld2CanvasSize(cnv as cdCanvas ptr, hw as souble, vw as double, hv as integer ptr, vv as integer ptr)
_DS_ wdCanvasCanvas2World(cnv as cdCanvas ptr, xv as integer, yv as integer, xw as double ptr, yw as double ptr)
_DS_ wdCanvasSetTransform(cnv as cdCanvas ptr, double sx, double sy, double tx, double ty)
_DS_ wdCanvasGetTransform(cnv as cdCanvas ptr, sx as double ptr, sy as double ptr, tx as double ptr, ty as double ptr)
_DS_ wdCanvasTranslate(cnv as cdCanvas ptr, dtx as double, dty as double)
_DS_ wdCanvasScale(cnv as cdCanvas ptr, dsx as double, dsy as double)

_DS_ wdCanvasClipArea(cnv as cdCanvas ptr, xmin as double, xmax as double, ymin as double, ymax as double);
_DF_ wdCanvasGetClipArea(cnv as cdCanvas ptr, xmin as double ptr, xmax as double ptr, ymin as double ptr, ymax as double ptr) as integer
_DF_ wdCanvasIsPointInRegion(cnv as cdCanvas ptr, x as double, y as double) as integer
_DS_ wdCanvasOffsetRegion(cnv as cdCanvas ptr, x as double, y as double)
_DS_ wdCanvasGetRegionBox(cnv as cdCanvas ptr, xmin as double ptr, xmax as double ptr, ymin as double ptr, ymax as double ptr)

_DS_ wdCanvasHardcopy(cnv as cdCanvas ptr, ctx as cdContext ptr, data_ as any ptr,func as draw_func)

' primitives
_DS_ wdCanvasPixel  (cnv as cdCanvas ptr, x as double, y as double, color_ as long)
_DS_ wdCanvasMark   (cnv as cdCanvas ptr, x as double, y as double)
_DS_ wdCanvasLine   (cnv as cdCanvas ptr, x as double, y as double, x2 as double, y2 as double)
_DS_ wdCanvasVertex (cnv as cdCanvas ptr, x as double, y as double)
_DS_ wdCanvasRect   (cnv as cdCanvas ptr, xmin as double, xmax as double, double ymin, ymax as double)
_DS_ wdCanvasBox    (cnv as cdCanvas ptr, xmin as double, xmax as double, double ymin, ymax as double)
_DS_ wdCanvasArc    (cnv as cdCanvas ptr, xc as double, yc as double, w as double, h as double, angle1 as double, angle2 as double)
_DS_ wdCanvasSector (cnv as cdCanvas ptr, xc as double, yc as double, w as double, h as double, angle1 as double, angle2 as double)
_DS_ wdCanvasChord  (cnv as cdCanvas ptr, xc as double, yc as double, w as double, h as double, angle1 as double, angle2 as double)
_DS_ wdCanvasText   (cnv as cdCanvas ptr, x as double, y as double, s as const zstring ptr)

_DS_ wdCanvasPutImageRect    (cnv as cdCanvas ptr, img as cdImage ptr, x as double, y as double, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ wdCanvasPutImageRectRGB (cnv as cdCanvas ptr, iw as integer, ih as integer, r as const ubyte ptr, g as const ubyte ptr, b as const ubyte ptr, x as double, y as double, w as double, h as double, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ wdCanvasPutImageRectRGBA(cnv as cdCanvas ptr, iw as integer, ih as integer, r as const ubyte ptr, g as const ubyte ptr, b as const ubyte ptr, a as const ubyte ptr, x as double, y as double, w as double, h as double, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ wdCanvasPutImageRectMap (cnv as cdCanvas ptr, iw as integer, ih as integer, index as const ubyte ptr, colors as const ulong ptr, x as double, y as double, w as double, h as double, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ wdCanvasPutBitmap       (cnv as cdCanvas ptr, bmp as cdBitmap ptr, x as double, y as double, w as double, h as double)

' attributes
_DF_ wdCanvasLineWidth(cnv as cdCanvas ptr, w as double) as double
_DF_ wdCanvasFont(cnv as cdCanvas ptr, type_face as const zstring ptr, style as integer, size as double) as integer 
_DS_ wdCanvasGetFont(cnv as cdCanvas ptr, type_face as zstring ptr, style as integer ptr, size as double ptr)
_DF_ wdCanvasMarkSize(cnv as cdCanvas ptr, size as double) as double
_DS_ wdCanvasGetFontDim(cnv as cdCanvas ptr, max_width as double ptr, height as double ptr, ascent as double ptr, descent as double ptr)
_DS_ wdCanvasGetTextSize(cnv as cdCanvas ptr, s as const zstring ptr, w as double ptr,h as double ptr)
_DS_ wdCanvasGetTextBox(cnv as cdCanvas ptr, x as double, y as double, s as const zstring ptr, xmin as double ptr, xmax as double ptr, ymin as double ptr, ymax as double ptr)
_DS_ wdCanvasGetTextBounds(cnv as cdCanvas ptr, x as double, y as double, s as const zstring ptr,rect as double ptr)
_DS_ wdCanvasStipple(cnv as cdCanvas ptr, w as integer, h as integer, fgbg as conxt ubyte ptr, w_mm as double, h_mm as double)
_DS_ wdCanvasPattern(cnv as cdCanvas ptr, w as integer, h as integer, color_ as const long ptr, w_mm as double, h_mm as double)

' vector text
_DS_ wdCanvasVectorTextDirection(cnv as cdCanvas ptr, x1 as double, y1 as double, x2 as double, y2 as double)
_DS_ wdCanvasVectorTextSize(cnv as cdCanvas ptr, size_x as double, size_y as double, s as const zstring ptr)
_DS_ wdCanvasGetVectorTextSize(cnv as cdCanvas ptr, s as const zstring ptr, x as double ptr, y as double ptr)
_DF_ wdCanvasVectorCharSize(cnv as cdCanvas ptr, size as double) as double
_DS_ wdCanvasVectorText(cnv as cdCanvas ptr, x as double, y as double, s as const zstring ptr)
_DS_ wdCanvasMultiLineVectorText(cnv as cdCanvas ptr, x as double, y as double, s as const zstring ptr)
_DS_ wdCanvasGetVectorTextBounds(cnv as cdCanvas ptr, s as const zstring ptr, x as double, y as double, rect as double ptr)
_DS_ wdCanvasGetVectorTextBox(cnv as cdCanvas ptr, x as double, y as double, s as const zstring ptr, xmin as double ptr, xmax as double ptr, ymin as double ptr, ymax as double ptr)


end extern


#ifndef CD_NO_OLD_INTERFACE
#include once "wd_old.bi"
#endif

#endif
